// This file handles the height fields used to
// form the ground.

#declare SandyColor =
//	color rgb <.34,.321,.156> // light, slightly yellow brownish sand
	color rgb<.33,.301,.136> // just right
//	color rgb <.30,.281,.116> // a little too dark, like dirt

#declare SandyTex =
	texture {
			pigment { SandyColor }
			finish { ambient .01 }
		}
#declare BumpySandTex =
	texture {
			pigment { SandyColor }
			normal { bumps .4 scale <2,4,2> }
			finish { ambient .01 }
		}

#declare DistantMountains =
	height_field {
		gif "HF1.gif"
		rotate x*90 // set up for RH coordinate system
		translate <-.5,.5,-0.005> //center on origin // sink it below local area
//		translate <-.5,.5,0> //center on origin
		texture { SandyTex }
		scale <40000,40000,800> // finally, scale it up
// NOTE: because of scaling, center region is about 8 below zero
	}

#declare LocalRoad =
	height_field {
		gif "RoadHF1.gif"
		rotate x*90 // set up for RH coordinate system
//		translate <-.5,.5,-0.1> //center on origin // sink it below local area
		translate <-.5,.5,0> //center on origin
		rotate z*90
		scale <500,800,16> // scale it up
		translate <0,0,-5>
		texture { BumpySandTex }
	}
